﻿using System;
namespace nGSO
{
    public interface IGsoEngine
    {
        SearchSpace StartGSOSolving();
        event ChangedAgentLocationEventHandler AgentMoved;
        event IterationCompletedHandler IterationCompleted;
        void Pause();
        void Resume();
        void Stop();
        GsoEngineStates CurrentState { get; }
    }
}
